<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Hdlc::Encoder Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d4/d27/classThread_1_1Hdlc_1_1Encoder.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../d6/def/classThread_1_1Hdlc_1_1Encoder-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Hdlc::Encoder Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements the HDLC-lite encoder.  
 <a href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">src/ncp/hdlc.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class defines a write iterator into a buffer used by <a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html" title="This class implements the HDLC-lite encoder. ">Encoder</a>.  <a href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab46533056028094a64768d238ad99a4c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#ab46533056028094a64768d238ad99a4c">Init</a> (<a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;aIterator)</td></tr>
<tr class="memdesc:ab46533056028094a64768d238ad99a4c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method begins an HDLC frame and puts the initial bytes into a buffer at the given <code>aIterator</code>.  <a href="#ab46533056028094a64768d238ad99a4c">More...</a><br /></td></tr>
<tr class="separator:ab46533056028094a64768d238ad99a4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89f6e268087e2fa6c1303f4566c131ed"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a89f6e268087e2fa6c1303f4566c131ed">Encode</a> (uint8_t aInByte, <a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;aIterator)</td></tr>
<tr class="memdesc:a89f6e268087e2fa6c1303f4566c131ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method encodes a single byte into a buffer at <code>aIterator</code>.  <a href="#a89f6e268087e2fa6c1303f4566c131ed">More...</a><br /></td></tr>
<tr class="separator:a89f6e268087e2fa6c1303f4566c131ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1dd8633eefe3efb8f8cf4eca28e61f4a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a1dd8633eefe3efb8f8cf4eca28e61f4a">Encode</a> (const uint8_t *aInBuf, uint16_t aInLength, <a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;aIterator)</td></tr>
<tr class="memdesc:a1dd8633eefe3efb8f8cf4eca28e61f4a"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method encodes the frame into a buffer at <code>aIterator</code>.  <a href="#a1dd8633eefe3efb8f8cf4eca28e61f4a">More...</a><br /></td></tr>
<tr class="separator:a1dd8633eefe3efb8f8cf4eca28e61f4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5513b8590576eb7008068fd953ad7ba7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a5513b8590576eb7008068fd953ad7ba7">Finalize</a> (<a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;aIterator)</td></tr>
<tr class="memdesc:a5513b8590576eb7008068fd953ad7ba7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method finalizes an HDLC frame.  <a href="#a5513b8590576eb7008068fd953ad7ba7">More...</a><br /></td></tr>
<tr class="separator:a5513b8590576eb7008068fd953ad7ba7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements the HDLC-lite encoder. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a89f6e268087e2fa6c1303f4566c131ed"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Hdlc::Encoder::Encode </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aInByte</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;&#160;</td>
          <td class="paramname"><em>aIterator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method encodes a single byte into a buffer at <code>aIterator</code>. </p>
<p>If there is no space to add the byte, the write iterator remains the same.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInByte</td><td>A byte to encode and add. </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aIterator</td><td>A reference to a write buffer iterator. On successful exit, the iterator is updated.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully encoded and added the byte. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to encode and add the byte. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_cgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_cgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_cgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_cgraph">
<area shape="rect" id="node2" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a8d6d63d2b1855c2a1dd6deb536ebf702" title="This method checks if there is buffer space available to write aWriteLength bytes. " alt="" coords="215,5,370,57"/>
<area shape="rect" id="node3" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a95fa42af34764041edf8901860560833" title="This method writes a byte to the buffer and updates the iterator (if space is available). " alt="" coords="215,81,370,133"/>
<area shape="rect" id="node4" href="../../d5/d0a/namespaceThread_1_1Hdlc.html#ad640cd8dadb4e659e0c8e7b4f43cf96f" title="This method updates an FCS. " alt="" coords="208,157,378,183"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_icgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_icgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_icgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_a89f6e268087e2fa6c1303f4566c131ed_icgraph">
<area shape="rect" id="node2" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a1dd8633eefe3efb8f8cf4eca28e61f4a" title="This method encodes the frame into a buffer at aIterator. " alt="" coords="208,5,363,44"/>
<area shape="rect" id="node3" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a5513b8590576eb7008068fd953ad7ba7" title="This method finalizes an HDLC frame. " alt="" coords="208,68,363,107"/>
<area shape="rect" id="node4" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="411,97,597,136"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a1dd8633eefe3efb8f8cf4eca28e61f4a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Hdlc::Encoder::Encode </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aInBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aInLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;&#160;</td>
          <td class="paramname"><em>aIterator</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method encodes the frame into a buffer at <code>aIterator</code>. </p>
<p>This method returns success only if there is space in buffer to encode the entire frame. If there is no space to encode the entire frame, the write iterator remains the same.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInBuf</td><td>A pointer to the input buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aInLength</td><td>The number of bytes in <code>aInBuf</code> to encode. </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aIterator</td><td>A reference to a write buffer iterator. On successful exit, the iterator is updated.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully encoded the HDLC frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to encode the HDLC frame. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_a1dd8633eefe3efb8f8cf4eca28e61f4a_cgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_a1dd8633eefe3efb8f8cf4eca28e61f4a_cgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_a1dd8633eefe3efb8f8cf4eca28e61f4a_cgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_a1dd8633eefe3efb8f8cf4eca28e61f4a_cgraph">
<area shape="rect" id="node2" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a89f6e268087e2fa6c1303f4566c131ed" title="This method encodes a single byte into a buffer at aIterator. " alt="" coords="208,88,363,127"/>
<area shape="rect" id="node3" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a8d6d63d2b1855c2a1dd6deb536ebf702" title="This method checks if there is buffer space available to write aWriteLength bytes. " alt="" coords="418,5,573,57"/>
<area shape="rect" id="node4" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a95fa42af34764041edf8901860560833" title="This method writes a byte to the buffer and updates the iterator (if space is available). " alt="" coords="418,81,573,133"/>
<area shape="rect" id="node5" href="../../d5/d0a/namespaceThread_1_1Hdlc.html#ad640cd8dadb4e659e0c8e7b4f43cf96f" title="This method updates an FCS. " alt="" coords="411,157,580,183"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a5513b8590576eb7008068fd953ad7ba7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Hdlc::Encoder::Finalize </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;&#160;</td>
          <td class="paramname"><em>aIterator</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method finalizes an HDLC frame. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aIterator</td><td>A reference to a write buffer iterator. On successful exit, the iterator is updated.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully ended the HDLC frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to end the HDLC frame. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_cgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_cgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_cgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_cgraph">
<area shape="rect" id="node2" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a89f6e268087e2fa6c1303f4566c131ed" title="This method encodes a single byte into a buffer at aIterator. " alt="" coords="208,76,363,115"/>
<area shape="rect" id="node4" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a95fa42af34764041edf8901860560833" title="This method writes a byte to the buffer and updates the iterator (if space is available). " alt="" coords="418,131,573,183"/>
<area shape="rect" id="node3" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a8d6d63d2b1855c2a1dd6deb536ebf702" title="This method checks if there is buffer space available to write aWriteLength bytes. " alt="" coords="418,5,573,57"/>
<area shape="rect" id="node5" href="../../d5/d0a/namespaceThread_1_1Hdlc.html#ad640cd8dadb4e659e0c8e7b4f43cf96f" title="This method updates an FCS. " alt="" coords="411,81,580,107"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_icgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_icgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_icgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_a5513b8590576eb7008068fd953ad7ba7_icgraph">
<area shape="rect" id="node2" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="208,5,394,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ab46533056028094a64768d238ad99a4c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Hdlc::Encoder::Init </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a> &amp;&#160;</td>
          <td class="paramname"><em>aIterator</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method begins an HDLC frame and puts the initial bytes into a buffer at the given <code>aIterator</code>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in,out]</td><td class="paramname">aIterator</td><td>A reference to a buffer write iterator. On successful exit, the iterator is updated.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully started the HDLC frame. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space available to start the HDLC frame. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_cgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_cgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_cgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_cgraph">
<area shape="rect" id="node2" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a95fa42af34764041edf8901860560833" title="This method writes a byte to the buffer and updates the iterator (if space is available). " alt="" coords="208,5,363,57"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_icgraph.png" border="0" usemap="#d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_icgraph" alt=""/></div>
<map name="d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_icgraph" id="d4/d27/classThread_1_1Hdlc_1_1Encoder_ab46533056028094a64768d238ad99a4c_icgraph">
<area shape="rect" id="node2" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="208,5,394,44"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/ncp/<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">hdlc.hpp</a></li>
<li>src/ncp/<a class="el" href="../../d5/d02/hdlc_8cpp.html">hdlc.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d5/d0a/namespaceThread_1_1Hdlc.html">Hdlc</a></li><li class="navelem"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html">Encoder</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
